Package icyllis.arc3d.granite.geom

# Class AnalyticArcStep

java.lang.Object
icyllis.arc3d.granite.GeometryStep
icyllis.arc3d.granite.geom.AnalyticArcStep

public class AnalyticArcStep extends GeometryStep
Analytic (SDF + HW derivatives) method to fill/stroke a butt/round/square stroked arc curve, a circular sector, or a circular segment. The join type may be square or round, for open arcs, and must be round for circular sector and circular segment. The arc must be circular, not elliptical.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class icyllis.arc3d.granite.GeometryStep

  `GeometryStep.ProgramImpl`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final VertexInputLayout.Attribute`
  `FLAGS_AND_DEPTH`
  Bitfield:
  16-32 bits: painter's depth;
  4-5 bits: join;
  2-4 bits: dir;
  join=0: round, join=1: miter;
  dir=0: inside, dir=1: center, dir=2: outside;
  `static final VertexInputLayout.AttributeSet`
  `INSTANCE_ATTRIBS`
  `static final VertexInputLayout.AttributeSet`
  `INSTANCE_ATTRIBS_FOR_ARC`
  `static final VertexInputLayout.Attribute`
  `LOCAL_ARC`
  (center X, center Y, start angle, sweep angle)
  `static final VertexInputLayout.Attribute`
  `RADII`
  X is circle radius.
  Y is stroke radius if stroked, or -1.0 if filled.
  Z is local AA radius.
  `static final VertexInputLayout.Attribute`
  `RADII_ARC`
  W is half width for open arcs.

  ### Fields inherited from class icyllis.arc3d.granite.GeometryStep

  `DEPTH, FLAG_EMIT_COVERAGE, FLAG_EMIT_PRIMITIVE_COLOR, FLAG_HANDLE_SOLID_COLOR, FLAG_HAS_TEXTURES, FLAG_OUTSET_BOUNDS_FOR_AA, FLAG_PERFORM_SHADING, MODEL_VIEW, SOLID_COLOR`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AnalyticArcStep(int type)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `appendToKey(KeyBuilder b)`
  Appends a key on the KeyBuilder that reflects any variety in the code that the geometry processor subclass can emit.
  `void`
  `emitFragmentColorCode(Formatter fs, String outputColor)`
  Emits the fragment color code into the fragment shader.
  `void`
  `emitFragmentCoverageCode(Formatter fs, String outputCoverage)`
  Emits the fragment coverage code into the fragment shader.
  `void`
  `emitVaryings(VaryingHandler varyingHandler, boolean usesFastSolidColor)`
  `void`
  `emitVertexGeomCode(Formatter vs, String worldPosVar, String localPosVar, boolean usesFastSolidColor)`
  Emits the geometry code into the vertex shader.
  `GeometryStep.ProgramImpl`
  `makeProgramImpl(ShaderCaps caps)`
  Returns a new instance of the appropriate implementation class for the given GeometryProcessor.
  `void`
  `writeMesh(MeshDrawWriter writer, Draw draw, float[] solidColor, boolean mayRequireLocalCoords)`

  ### Methods inherited from class icyllis.arc3d.granite.GeometryStep

  `appendAttributesToKey, depthStencilFlags, depthStencilSettings, emitSamplers, emitsCoverage, emitsPrimitiveColor, emitUniforms, getInputLayout, handlesSolidColor, hasInstanceAttributes, hasVertexAttributes, instanceAttributes, instanceBinding, instanceStride, makeColorAttribute, name, numInstanceAttributes, numInstanceLocations, numTextureSamplers, numVertexAttributes, numVertexLocations, performsShading, primitiveType, textureSamplerState, textureSamplerSwizzle, uniqueID, vertexAttributes, vertexBinding, vertexStride, writeUniformsAndTextures`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### LOCAL_ARC

    public static final VertexInputLayout.Attribute LOCAL_ARC
    (center X, center Y, start angle, sweep angle)

  - ### RADII

    public static final VertexInputLayout.Attribute RADII
    X is circle radius.
    Y is stroke radius if stroked, or -1.0 if filled.
    Z is local AA radius.

  - ### RADII_ARC

    public static final VertexInputLayout.Attribute RADII_ARC
    W is half width for open arcs.

  - ### FLAGS_AND_DEPTH

    public static final VertexInputLayout.Attribute FLAGS_AND_DEPTH
    Bitfield:
    16-32 bits: painter's depth;
    4-5 bits: join;
    2-4 bits: dir;
    join=0: round, join=1: miter;
    dir=0: inside, dir=1: center, dir=2: outside;

  - ### INSTANCE_ATTRIBS

    public static final VertexInputLayout.AttributeSet INSTANCE_ATTRIBS

  - ### INSTANCE_ATTRIBS_FOR_ARC

    public static final VertexInputLayout.AttributeSet INSTANCE_ATTRIBS_FOR_ARC

- ## Constructor Details

  - ### AnalyticArcStep

    public AnalyticArcStep(int type)

- ## Method Details

  - ### appendToKey

    public void appendToKey(@Nonnull KeyBuilder b)
    Description copied from class: `GeometryStep`
    Appends a key on the KeyBuilder that reflects any variety in the code that the geometry processor subclass can emit.
    Specified by:
      `appendToKey` in class `GeometryStep`
    See Also:
      - `GeometryStep.makeProgramImpl(ShaderCaps)`

  - ### makeProgramImpl

    @Nonnull public GeometryStep.ProgramImpl makeProgramImpl(ShaderCaps caps)
    Description copied from class: `GeometryStep`
    Returns a new instance of the appropriate implementation class for the given GeometryProcessor. This method is called only when the specified key does not exist in the program cache.
    Specified by:
      `makeProgramImpl` in class `GeometryStep`
    See Also:
      - `GeometryStep.appendToKey(KeyBuilder)`

  - ### emitVaryings

    public void emitVaryings(VaryingHandler varyingHandler, boolean usesFastSolidColor)
    Overrides:
      `emitVaryings` in class `GeometryStep`

  - ### emitVertexGeomCode

    public void emitVertexGeomCode(Formatter vs, @Nonnull String worldPosVar, @Nullable String localPosVar, boolean usesFastSolidColor)
    Description copied from class: `GeometryStep`
    Emits the geometry code into the vertex shader. Implementation must define "vec4 worldPosVar" with the given name and setup it. If localPosVar is not null, then it must write geometry's local pos to it.
    Overrides:
      `emitVertexGeomCode` in class `GeometryStep`

  - ### emitFragmentColorCode

    public void emitFragmentColorCode(Formatter fs, String outputColor)
    Description copied from class: `GeometryStep`
    Emits the fragment color code into the fragment shader. This is either paint's solid color or per-vertex primitive color. See `GeometryStep.FLAG_HANDLE_SOLID_COLOR` and `GeometryStep.FLAG_EMIT_PRIMITIVE_COLOR`.
    Overrides:
      `emitFragmentColorCode` in class `GeometryStep`

  - ### emitFragmentCoverageCode

    public void emitFragmentCoverageCode(Formatter fs, String outputCoverage)
    Description copied from class: `GeometryStep`
    Emits the fragment coverage code into the fragment shader.

    If `GeometryStep.emitsCoverage()` is false, this method is called for hard-edge coverage, discard the fragment if coverage is 0. Otherwise outputCoverage is non-null, and coverage will involve in blending operations.

    Overrides:
      `emitFragmentCoverageCode` in class `GeometryStep`

  - ### writeMesh

    public void writeMesh(MeshDrawWriter writer, Draw draw, @Nullable float[] solidColor, boolean mayRequireLocalCoords)
    Overrides:
      `writeMesh` in class `GeometryStep`